// Package basic provides a basic representation of dosini-style documents
package basic

// Document represents an INI-style document
type Document struct {
	Global []Field

	Sections []Section
}

// Section represents an INI-style section with optional GIT-style IDs
type Section struct {
	Key     string
	ID      string
	EmptyID bool

	Fields []Field
}

// Field represents a key = value entry in an INI-style document
type Field struct {
	Key   string
	Value string
}
